/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.abmyers.spinfw.action;

import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

/**
 *
 * @author amyers
 */
public class ActionContext {

    @SuppressWarnings("rawtypes")
	private Map attributeMap;
    private String view;
    private String redirectTo;
    private HttpServletRequest request;
    private Map<String, String> parameterNamesLC;

    @SuppressWarnings("rawtypes")
	public ActionContext(String viewString, HttpServletRequest request) {
        this.attributeMap = new HashMap();
        this.view = viewString;
        this.request = request;
        populateParameterNamesLC();
    }

    @SuppressWarnings("rawtypes")
	public Map getAttributeMap() {
        return attributeMap;
    }

    @SuppressWarnings("rawtypes")
	public void setAttributeMap(Map attributeMap) {
        this.attributeMap = attributeMap;
    }

    public String getView() {
        return view;
    }

    public void setView(String view) {
        this.view = view;
    }

    @SuppressWarnings("unchecked")
    public void putAttribute(String key, Object obj) {
        attributeMap.put(key, obj);
    }

    public HttpServletRequest getRequest() {
        return request;
    }

    public HttpSession getSession() {
        return request.getSession();
    }

    public String getParam(String parameterName) {
        return request.getParameter(parameterName);
    }

    public String[] getParameterValues(String parameterName) {
        return request.getParameterValues(parameterName);
    }

    public String getViewSection() {
        if (this.view != null) {
            String[] result = view.split("\\.");
            return result[0].toLowerCase();
        } else {
            return null;
        }
    }

    public String getViewItem() {
        String retVal = null;
        if (this.view != null) {
            String[] result = view.split("\\.");
            if (result.length > 0) {
                retVal = result[1].toLowerCase();
            } else {
                retVal = null;
            }
        }
        return retVal;
    }

    @SuppressWarnings("rawtypes")
	public Map getRc() {
    	return attributeMap;
    }

    private void populateParameterNamesLC() {
    	parameterNamesLC = new HashMap<String, String>();
        for (@SuppressWarnings("unchecked")
		Enumeration<String> e = request.getParameterNames() ; e.hasMoreElements() ;) {
        	String currentElement = e.nextElement();
        	parameterNamesLC.put(currentElement.toLowerCase(), currentElement);
        }
    }

    public boolean containsParameterNoCase(String parameterName) {
    	// because equals only compares the key, can pass in a dummy value of null
    	return parameterNamesLC.containsKey(parameterName.toLowerCase());
    }

    public String getParameterNoCase(String parameterName) {
    	return request.getParameter(parameterNamesLC.get(parameterName.toLowerCase()));
    }

	public String getRedirectTo() {
		return redirectTo;
	}

	public void setRedirectTo(String redirectTo) {
		this.redirectTo = redirectTo;
	}
}
