package com.abmyers.spinfw.tags;

import java.io.IOException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspTagException;
import javax.servlet.jsp.tagext.BodyTagSupport;

import com.abmyers.utils.Framework;

public class LinkTag extends BodyTagSupport {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;
	private String action;
	private String queryString;

	public int doEndTag() throws JspException {

		StringBuffer sb = new StringBuffer();
		sb.append(Framework.createHref(pageContext.getServletContext().getContextPath(), (String) pageContext.getServletContext().getAttribute("actionPath"), action));

		if (queryString != null) {
			sb.append("?" + queryString);
		}

		sb.insert(0, "<a href=\"");
		sb.append("\">");
		sb.append(bodyContent.getString().trim());
		sb.append("</a>");

		try {
			pageContext.getOut().write(sb.toString());
		} catch (IOException e) {
			throw new JspTagException(e.toString(), e);
		}

		return EVAL_PAGE;
	}

	public String getAction() {
		return action;
	}

	public void setAction(String action) {
		this.action = action;
	}

	public String getQueryString() {
		return queryString;
	}

	public void setQueryString(String queryString) {
		this.queryString = queryString;
	}
}
