/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.abmyers.utils;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * 
 * @author amyers
 */
public class StringUtils {

	public static final String DEFAULT_SNAKE_CASE_SEPARATOR = "_";

	public static String convertSnakeToCamelCase(final String strToConvert,
			boolean uppercaseFirstChar) {
		String result = "";
		String separatorToUse = DEFAULT_SNAKE_CASE_SEPARATOR;

		// The algorithm is as follows.
		// 1. Convert everything to LowerCase.
		// 2. Convert the first char to upper
		// 3. Convert each char after the sep to upper
		// 4. Remove the seps

		// First make it null safe
		if (strToConvert == null) {
			return null;
		}

		// Ensure string is more than one character long
		if (strToConvert.length() <= 1) {
			return strToConvert;
		}

		result = strToConvert.toLowerCase();
		if (uppercaseFirstChar) {
			result = strToConvert.substring(0, 1).toUpperCase()
					+ strToConvert.substring(1);
		}
		StringBuffer sb = new StringBuffer();
		Pattern p = Pattern.compile(separatorToUse + "([a-z])");
		Matcher m = p.matcher(result);
		while (m.find()) {
			m.appendReplacement(sb, m.group(1).toUpperCase());
		}

		m.appendTail(sb);

		result = sb.toString();

		return result;
	}

	public static String convertCamelCaseToTitleCase(String strToConvert) {

		String result = "";

		// The algorithm is as follows.
		// 1. Add a space after each capital letter
		// 2. Convert the first char to upper

		// First make it null safe
		if (strToConvert == null) {
			return null;
		}

		// Ensure string is more than one character long
		if (strToConvert.length() <= 1) {
			return strToConvert;
		}

		StringBuffer sb = new StringBuffer();
		Pattern p = Pattern.compile("([A-Z])");
		Matcher m = p.matcher(strToConvert);
		while (m.find()) {
			m.appendReplacement(sb, " " + m.group(1).toUpperCase());
		}

		m.appendTail(sb);

		result = sb.toString();

		result = result.substring(0, 1).toUpperCase() + result.substring(1);

		return result;
	}

}
